#include <iostream>
#include <cmath>
#include <cstdlib>

#include "PolyAbstr.hpp"

using namespace std;

template <typename Coeff> void Polynom<Coeff>::zero() { monoms.clear(); };

template <typename Coeff>
void Polynom<Coeff>::set_coeff(int degree, Coeff coeff) {
  if (degree >= 0) {
    if (coeff != 0)
      monoms[degree] = coeff;
    else
      monoms.erase(degree);
  } else {
    cerr << "Mauvais degré " << degree << " set_coeff impossible !" << endl;
  }
}

template <typename Coeff> int Polynom<Coeff>::degree() const {
  int res{-1};

  typename std::map<int,Coeff>::const_iterator it;
  for (it = monoms.begin(); it != monoms.end(); ++it)
     if (res < it->first) res = it->first;

  // Le compilateur des salles de TP est trop vieux pour ca...
  // for (const auto elem : monoms)
  //  res = max(res, elem.first);

  return res;
}

template <typename Coeff> Coeff Polynom<Coeff>::coeff(int d) const {
  double degree{0.};
  auto it = monoms.find(d);
  if (it != monoms.end())
    degree = it->second;

  return degree;
}

template <typename Coeff> bool Polynom<Coeff>::is_zero() const {
  return monoms.empty();
};

float Puissance(float x, int degree) {
  if (degree < 0) {
    cerr << "Impossible de calculer une puissance négative." << endl;
    exit(EXIT_FAILURE);
    // Le compilateur des salles de TP est trop vieux pour ca...
    //        throw runtime_error{"Impossible de calculer une puissance négative."};
  }
    if (degree == 0)
        return 1.;

    float res{x};
    for (int i = 1; i < degree; i++)
        res *= x;
    return res;
}

/////////////////////////////////////////////////////////////////////////////////
//   fonctions wrapper pour que les étudiants n'ai pas à toucher de l'objet:   //
/////////////////////////////////////////////////////////////////////////////////

typedef Polynom<float> Polynome;

void PolynomeNul(Polynome &p) { p.zero(); }
void ModifierCoeffPoly(Polynome &p, int d, float co) { p.set_coeff(d, co); }
int DegrePoly(const Polynome &p) { return p.degree(); }
float CoeffPoly(const Polynome &p, int d) { return p.coeff(d); }
bool EstNulPoly(const Polynome &p) { return p.is_zero(); }
